function save_map_data(distance)

--This exports current map data as an array of entities and tiles

local data = "tiles = \n{\n"
  for X = -distance,distance do
    for Y = -distance, distance do
      local tile = game.surfaces[1].get_tile(X,Y)
      local name = tile.name
      if name ~= "out-of-map" then
      local position = tile.position
      data = data.."  {name = \""..name.."\", position = {"..position.x..","..position.y.."}},\n"
      end
    end
  end
  data = data.."\n}\n\n".."entities = \n{\n"
  for k, entity in pairs (game.surfaces[1].find_entities({{-distance,-distance},{distance,distance}})) do
    local name = entity.name
    local position = entity.position
    local direction = entity.direction
    local force = entity.force
    if entity.name == "express-loader" then
      local loader_type = entity.loader_type
      data = data.."  {name = \""..name.."\", position = {"..position.x..","..position.y.."}, force = \""..force.name.."\", direction = "..direction..", type = \""..loader_type.."\"},\n"
    elseif entity.type = "resource" then
      local amount = entity.amount
      data = data.."  {name = \""..name.."\", position = {"..position.x..","..position.y.."}, amount = \""..amount.."\"},\n"
    else
      data = data.."  {name = \""..name.."\", position = {"..position.x..","..position.y.."}, force = \""..force.name.."\", direction = "..direction.."},\n"
    end
  end
  data = data.."\n}"
  game.write_file("tile_data.lua",data)
end



function recreate_map(tiles,entities, offset_x, offset_y, force)

--This creates a section of map using an array of tiles and entities
  local offset_tiles = {}
  
  for k, tile in pairs (tiles) do
    offset_tiles[k] = {name = tile.name, position = {tile.position.x+offset_x, tile.position.y+offset_y}}
  end
  game.surfaces[1].set_tiles(offset_tiles,true)
  for k, entity in pairs (entities) do
  if entity.type == "resource" then
    game.surfaces[1].create_entity({name = entity.name, position = {entity.position.x+offset_x, entity.position.y+offset_y}, amount = entity.amount})
  else
    game.surfaces[1].create_entity({name = entity.name, position = {entity.position.x+offset_x, entity.position.y+offset_y}, force = force})
  end

end



















